---
product: "AG Grid"
title: "Cell Selection"
description: "Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the , or for doing aggregations using the ."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Row Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Selection

Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the [Clipboard](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/clipboard/), or for doing aggregations using the [Status Bar](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/status-bar/).

## Enabling Cell Selection

Cell Selection is enabled by setting the `gridOptions.cellSelection` to `true`, or to a configuration object.

```js
const gridOptions = {
    cellSelection: true,

    // other grid options ...
}
```

When enabled, ranges can be selected in the following ways:

- **Mouse Drag:** Click the mouse down on a cell and drag and release the mouse over another cell. A range will be created between the two cells and clear any existing ranges.
- **Ctrl & Mouse Drag:** Holding `^ Ctrl` key while creating a range using mouse drag **outside an existing range** will create a new cell range selection and keep any existing ranges.
- **Shift & Click:** Clicking on one cell to focus that cell, then holding down `⇧ Shift` while clicking another cell, will create a range between both cells.
- **Shift & Arrow Keys:** Focusing a cell and then holding down `⇧ Shift` and using the arrow keys will create a range starting from the focused cell.
- **Ctrl & Shift & Arrow Keys:** Focusing a cell and then holding down `^ Ctrl` + `⇧ Shift` and using the arrow keys will create a range starting from the focused cell to the last cell in the direction of the Arrow pressed.

### Cell Range Deselection

It is possible to deselect part of existing ranges in the following ways:

- **Ctrl & Mouse Drag:** Holding `^ Ctrl` and dragging a range starting **within an existing range** will cause any cells covered by the new range to be deselected.
- **Ctrl & Click:** Holding `^ Ctrl` and clicking a cell will deselect just that cell.

Note that deselecting part of a range can split the range into multiple ranges, since individual ranges have the limitation of being rectangular.

The example below demonstrates simple cell selection. Cell ranges can be selected in all the ways described above.

#### Cell Range Selection and Deselection

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  cellSelection: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Cell Range Selection and Deselection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection/typescript/)

## Prevent Selection of Multiple Ranges

By default multiple ranges can be selected. To restrict cell selection to a single range, even if the `^ Ctrl` key is held down, set `cellSelection.suppressMultiRanges` to `true`.

```js
const gridOptions = {
    cellSelection: {
        suppressMultiRanges: true,
    },

    // other grid options ...
}
```

The following example demonstrates single range cell selection:

#### Cell Range Selection Suppress Multi

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
  },
  cellSelection: { suppressMultiRanges: true },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi.setGridOption("rowData", data));
```

[Live example: Cell Range Selection Suppress Multi](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-suppress-multi/typescript/)

## Selecting Cells via Column Headers

Users can select all visible cells in a column by setting `cellSelection.enableColumnSelection` to `true` and either clicking a column header, or pressing the `↵ Enter` key when the column header is focused.

- By default, when selecting a column, all other ranges are cleared. If you wish to keep existing selections, hold `^ Ctrl` and then select a column header.
- Cells that have been selected via column selection may be de-selected by holding `^ Ctrl` and then clicking the column header.
- Users can extend the range of a column selection by holding `⇧ Shift` and then clicking on another column header.
- When interacting via the keyboard, users may press `↵ Enter` while a column header is focussed instead of clicking a column header.

This feature is illustrated in the example below, which uses the following configuration:

```js
const gridOptions = {
    cellSelection: {
        enableColumnSelection: true,
    },

    // other grid options ...
}
```

#### Cell Selection via Column Headers

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    {
      headerName: "Category A1",
      children: [
        { field: "age", maxWidth: 90 },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Category B1",
      children: [
        {
          headerName: "Category B2",
          children: [
            { field: "year", maxWidth: 90 },
            { field: "date", minWidth: 150 },
            { field: "sport", minWidth: 150 },
            { field: "gold" },
            { field: "silver" },
            { field: "bronze" },
            { field: "total" },
          ],
        },
      ],
    },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  cellSelection: {
    enableColumnSelection: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Cell Selection via Column Headers](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/column-header-cell-selection/typescript/)

> **Note**
>
> When column selection is enabled, [Row Sorting](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-sorting/) requires holding down the `⌥ Alt` key in addition to the normal interaction (i.e. clicking or pressing `↵ Enter`).
>
> Similarly [Column Group Expansion](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-groups/) via keyboard requires holding down the `⌥ Alt` key in addition to pressing `↵ Enter`.

## Ranges with Pinned Columns and Rows

It is possible to select a cell range that spans pinned and non-pinned sections of the grid. If you do this, the selected range will not have any gaps with regards to the column or row order.

For example, if you start the drag on the left pinned area and drag to the right pinned area, then all of the columns in the centre area will also be part of the range. Likewise with pinned rows, no row gaps will occur if a cell range spans into pinned rows. A range will be continuous between the rows pinned to the top, the centre, and the rows pinned to the bottom.

This can be thought of as follows: if you have a grid with pinned rows and / or columns, then 'flatten out' the grid in your head so that all rows and columns are visible, then the cell selection will work as you would expect in the flattened out version where only full rectangles can be selectable.

#### Cell Range Selection and Pinned Areas

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  PinnedRowModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  PinnedRowModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150, pinned: "left" },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total", pinned: "right" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  cellSelection: true,
  enableRowPinning: true,
  isRowPinned: (node) => {
    const country = node.data?.country;
    return country == "Norway" ? "top" : null;
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Cell Range Selection and Pinned Areas](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-pinned-areas/typescript/)

## Highlight Headers

It is possible to highlight the Grid Headers that are part of a range by setting the `cellSelection.enableHeaderHighlight` to `true`.

```js
const gridOptions = {
    cellSelection: {
        enableHeaderHighlight: true,
    },

    // other grid options ...
}
```

#### Cell Range Selection Header Highlight

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  cellSelection: {
    enableHeaderHighlight: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Cell Range Selection Header Highlight](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-highlight-headers/typescript/)

## Editing Within a Cell Selection

When [Cell Editing](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing/) is enabled, a cell selection can be used to edit many cells at once.

### Copy Cell Range Down

When you have more than one row selected in a range, pressing keys `^ Ctrl`+`D` will copy the top row values to all other rows in the selected range.

By default, the Value Formatter and Value Parser will be used whilst copying the range via the [Use Value Formatter For Export](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-formatters/#formatting-for-export) and [Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-parsers/#use-value-parser-for-import) features.

### Bulk Cell Edit

When a cell range is selected, typing to enter a new value and pressing the `^ Ctrl`+`↵ Enter` keys will set the newly provided cell value to all the editable cells in the selected cell range.

### Delete Cell Range

Pressing the `Delete` key will clear all of the cells in the range (by setting the cell values to `null`). If your column uses a `valueParser`, it will receive an empty string (`''`) as the new value.

This will also emit the following events:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellSelectionDeleteStart` | `CellSelectionDeleteStartEvent` |  |  |  |
| `cellSelectionDeleteEnd` | `CellSelectionDeleteEndEvent` |  |  |  |

### Example

The example below has editing enabled on all columns. Select a range of cells, then try each of the interactions described above.

#### Editing Within a Cell Selection

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
  },
  cellSelection: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Editing Within a Cell Selection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-editing/typescript/)

## API Reference

> **Note**
>
> The cell selection state can be saved and restored as part of [Grid State](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/).

Here you can find a full list of configuration options for `cellSelection`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressMultiRanges` | `boolean` |  |  |  |
| `enableHeaderHighlight` | `boolean` |  |  |  |
| `enableColumnSelection` | `boolean` |  |  |  |
| `handle` | `RangeHandleOptions \| FillHandleOptions` |  |  |  |


---
product: "AG Grid"
title: "Cell Selection"
description: "Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the , or for doing aggregations using the ."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Row Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Selection

Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the [Clipboard](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/clipboard/), or for doing aggregations using the [Status Bar](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/status-bar/).

## Enabling Cell Selection

Cell Selection is enabled by setting the `gridOptions.cellSelection` to `true`, or to a configuration object.

```ts
<ag-grid-vue
    :cellSelection="cellSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.cellSelection = true;
```

When enabled, ranges can be selected in the following ways:

- **Mouse Drag:** Click the mouse down on a cell and drag and release the mouse over another cell. A range will be created between the two cells and clear any existing ranges.
- **Ctrl & Mouse Drag:** Holding `^ Ctrl` key while creating a range using mouse drag **outside an existing range** will create a new cell range selection and keep any existing ranges.
- **Shift & Click:** Clicking on one cell to focus that cell, then holding down `⇧ Shift` while clicking another cell, will create a range between both cells.
- **Shift & Arrow Keys:** Focusing a cell and then holding down `⇧ Shift` and using the arrow keys will create a range starting from the focused cell.
- **Ctrl & Shift & Arrow Keys:** Focusing a cell and then holding down `^ Ctrl` + `⇧ Shift` and using the arrow keys will create a range starting from the focused cell to the last cell in the direction of the Arrow pressed.

### Cell Range Deselection

It is possible to deselect part of existing ranges in the following ways:

- **Ctrl & Mouse Drag:** Holding `^ Ctrl` and dragging a range starting **within an existing range** will cause any cells covered by the new range to be deselected.
- **Ctrl & Click:** Holding `^ Ctrl` and clicking a cell will deselect just that cell.

Note that deselecting part of a range can split the range into multiple ranges, since individual ranges have the limitation of being rectangular.

The example below demonstrates simple cell selection. Cell ranges can be selected in all the ways described above.

#### Cell Range Selection and Deselection

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Range Selection and Deselection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection/vue3/)

## Prevent Selection of Multiple Ranges

By default multiple ranges can be selected. To restrict cell selection to a single range, even if the `^ Ctrl` key is held down, set `cellSelection.suppressMultiRanges` to `true`.

```ts
<ag-grid-vue
    :cellSelection="cellSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.cellSelection = {
    suppressMultiRanges: true,
};
```

The following example demonstrates single range cell selection:

#### Cell Range Selection Suppress Multi

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="cellSelection"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
    });
    const cellSelection = ref<boolean | CellSelectionOptions>({
      suppressMultiRanges: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      cellSelection,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Range Selection Suppress Multi](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-suppress-multi/vue3/)

## Selecting Cells via Column Headers

Users can select all visible cells in a column by setting `cellSelection.enableColumnSelection` to `true` and either clicking a column header, or pressing the `↵ Enter` key when the column header is focused.

- By default, when selecting a column, all other ranges are cleared. If you wish to keep existing selections, hold `^ Ctrl` and then select a column header.
- Cells that have been selected via column selection may be de-selected by holding `^ Ctrl` and then clicking the column header.
- Users can extend the range of a column selection by holding `⇧ Shift` and then clicking on another column header.
- When interacting via the keyboard, users may press `↵ Enter` while a column header is focussed instead of clicking a column header.

This feature is illustrated in the example below, which uses the following configuration:

```ts
<ag-grid-vue
    :cellSelection="cellSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.cellSelection = {
    enableColumnSelection: true,
};
```

#### Cell Selection via Column Headers

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="cellSelection"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      { field: "athlete", minWidth: 150 },
      {
        headerName: "Category A1",
        children: [
          { field: "age", maxWidth: 90 },
          { field: "country", minWidth: 150 },
        ],
      },
      {
        headerName: "Category B1",
        children: [
          {
            headerName: "Category B2",
            children: [
              { field: "year", maxWidth: 90 },
              { field: "date", minWidth: 150 },
              { field: "sport", minWidth: 150 },
              { field: "gold" },
              { field: "silver" },
              { field: "bronze" },
              { field: "total" },
            ],
          },
        ],
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const cellSelection = ref<boolean | CellSelectionOptions>({
      enableColumnSelection: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      cellSelection,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Selection via Column Headers](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/column-header-cell-selection/vue3/)

> **Note**
>
> When column selection is enabled, [Row Sorting](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-sorting/) requires holding down the `⌥ Alt` key in addition to the normal interaction (i.e. clicking or pressing `↵ Enter`).
>
> Similarly [Column Group Expansion](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-groups/) via keyboard requires holding down the `⌥ Alt` key in addition to pressing `↵ Enter`.

## Ranges with Pinned Columns and Rows

It is possible to select a cell range that spans pinned and non-pinned sections of the grid. If you do this, the selected range will not have any gaps with regards to the column or row order.

For example, if you start the drag on the left pinned area and drag to the right pinned area, then all of the columns in the centre area will also be part of the range. Likewise with pinned rows, no row gaps will occur if a cell range spans into pinned rows. A range will be continuous between the rows pinned to the top, the centre, and the rows pinned to the bottom.

This can be thought of as follows: if you have a grid with pinned rows and / or columns, then 'flatten out' the grid in your head so that all rows and columns are visible, then the cell selection will work as you would expect in the flattened out version where only full rectangles can be selectable.

#### Cell Range Selection and Pinned Areas

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IsRowPinned,
  ModuleRegistry,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  PinnedRowModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :enableRowPinning="true"
      :isRowPinned="isRowPinned"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150, pinned: "left" },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total", pinned: "right" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const isRowPinned = ref<IsRowPinned>((node) => {
      const country = node.data?.country;
      return country == "Norway" ? "top" : null;
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      isRowPinned,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Range Selection and Pinned Areas](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-pinned-areas/vue3/)

## Highlight Headers

It is possible to highlight the Grid Headers that are part of a range by setting the `cellSelection.enableHeaderHighlight` to `true`.

```ts
<ag-grid-vue
    :cellSelection="cellSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.cellSelection = {
    enableHeaderHighlight: true,
};
```

#### Cell Range Selection Header Highlight

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="cellSelection"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const cellSelection = ref<boolean | CellSelectionOptions>({
      enableHeaderHighlight: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      cellSelection,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell Range Selection Header Highlight](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-highlight-headers/vue3/)

## Editing Within a Cell Selection

When [Cell Editing](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing/) is enabled, a cell selection can be used to edit many cells at once.

### Copy Cell Range Down

When you have more than one row selected in a range, pressing keys `^ Ctrl`+`D` will copy the top row values to all other rows in the selected range.

By default, the Value Formatter and Value Parser will be used whilst copying the range via the [Use Value Formatter For Export](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/#formatting-for-export) and [Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-parsers/#use-value-parser-for-import) features.

### Bulk Cell Edit

When a cell range is selected, typing to enter a new value and pressing the `^ Ctrl`+`↵ Enter` keys will set the newly provided cell value to all the editable cells in the selected cell range.

### Delete Cell Range

Pressing the `Delete` key will clear all of the cells in the range (by setting the cell values to `null`). If your column uses a `valueParser`, it will receive an empty string (`''`) as the new value.

This will also emit the following events:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellSelectionDeleteStart` | `CellSelectionDeleteStartEvent` |  |  |  |
| `cellSelectionDeleteEnd` | `CellSelectionDeleteEndEvent` |  |  |  |

### Example

The example below has editing enabled on all columns. Select a range of cells, then try each of the interactions described above.

#### Editing Within a Cell Selection

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", maxWidth: 90 },
      { field: "country", minWidth: 150 },
      { field: "year", maxWidth: 90 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Editing Within a Cell Selection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-editing/vue3/)

## API Reference

> **Note**
>
> The cell selection state can be saved and restored as part of [Grid State](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/).

Here you can find a full list of configuration options for `cellSelection`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressMultiRanges` | `boolean` |  |  |  |
| `enableHeaderHighlight` | `boolean` |  |  |  |
| `enableColumnSelection` | `boolean` |  |  |  |
| `handle` | `RangeHandleOptions \| FillHandleOptions` |  |  |  |


---
product: "AG Grid"
title: "Cell Selection"
description: "Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the , or for doing aggregations using the ."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Row Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Selection

Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the [Clipboard](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/clipboard/), or for doing aggregations using the [Status Bar](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/status-bar/).

## Enabling Cell Selection

Cell Selection is enabled by setting the `gridOptions.cellSelection` to `true`, or to a configuration object.

```ts
<ag-grid-angular
    [cellSelection]="cellSelection"
    /* other grid options ... */ />

this.cellSelection = true;
```

When enabled, ranges can be selected in the following ways:

- **Mouse Drag:** Click the mouse down on a cell and drag and release the mouse over another cell. A range will be created between the two cells and clear any existing ranges.
- **Ctrl & Mouse Drag:** Holding `^ Ctrl` key while creating a range using mouse drag **outside an existing range** will create a new cell range selection and keep any existing ranges.
- **Shift & Click:** Clicking on one cell to focus that cell, then holding down `⇧ Shift` while clicking another cell, will create a range between both cells.
- **Shift & Arrow Keys:** Focusing a cell and then holding down `⇧ Shift` and using the arrow keys will create a range starting from the focused cell.
- **Ctrl & Shift & Arrow Keys:** Focusing a cell and then holding down `^ Ctrl` + `⇧ Shift` and using the arrow keys will create a range starting from the focused cell to the last cell in the direction of the Arrow pressed.

### Cell Range Deselection

It is possible to deselect part of existing ranges in the following ways:

- **Ctrl & Mouse Drag:** Holding `^ Ctrl` and dragging a range starting **within an existing range** will cause any cells covered by the new range to be deselected.
- **Ctrl & Click:** Holding `^ Ctrl` and clicking a cell will deselect just that cell.

Note that deselecting part of a range can split the range into multiple ranges, since individual ranges have the limitation of being rectangular.

The example below demonstrates simple cell selection. Cell ranges can be selected in all the ways described above.

#### Cell Range Selection and Deselection

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Range Selection and Deselection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection/angular/)

## Prevent Selection of Multiple Ranges

By default multiple ranges can be selected. To restrict cell selection to a single range, even if the `^ Ctrl` key is held down, set `cellSelection.suppressMultiRanges` to `true`.

```ts
<ag-grid-angular
    [cellSelection]="cellSelection"
    /* other grid options ... */ />

this.cellSelection = {
    suppressMultiRanges: true,
};
```

The following example demonstrates single range cell selection:

#### Cell Range Selection Suppress Multi

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="cellSelection"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
  };
  cellSelection: boolean | CellSelectionOptions = { suppressMultiRanges: true };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Range Selection Suppress Multi](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-suppress-multi/angular/)

## Selecting Cells via Column Headers

Users can select all visible cells in a column by setting `cellSelection.enableColumnSelection` to `true` and either clicking a column header, or pressing the `↵ Enter` key when the column header is focused.

- By default, when selecting a column, all other ranges are cleared. If you wish to keep existing selections, hold `^ Ctrl` and then select a column header.
- Cells that have been selected via column selection may be de-selected by holding `^ Ctrl` and then clicking the column header.
- Users can extend the range of a column selection by holding `⇧ Shift` and then clicking on another column header.
- When interacting via the keyboard, users may press `↵ Enter` while a column header is focussed instead of clicking a column header.

This feature is illustrated in the example below, which uses the following configuration:

```ts
<ag-grid-angular
    [cellSelection]="cellSelection"
    /* other grid options ... */ />

this.cellSelection = {
    enableColumnSelection: true,
};
```

#### Cell Selection via Column Headers

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="cellSelection"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: (ColDef | ColGroupDef)[] = [
    { field: "athlete", minWidth: 150 },
    {
      headerName: "Category A1",
      children: [
        { field: "age", maxWidth: 90 },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Category B1",
      children: [
        {
          headerName: "Category B2",
          children: [
            { field: "year", maxWidth: 90 },
            { field: "date", minWidth: 150 },
            { field: "sport", minWidth: 150 },
            { field: "gold" },
            { field: "silver" },
            { field: "bronze" },
            { field: "total" },
          ],
        },
      ],
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  cellSelection: boolean | CellSelectionOptions = {
    enableColumnSelection: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Selection via Column Headers](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/column-header-cell-selection/angular/)

> **Note**
>
> When column selection is enabled, [Row Sorting](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-sorting/) requires holding down the `⌥ Alt` key in addition to the normal interaction (i.e. clicking or pressing `↵ Enter`).
>
> Similarly [Column Group Expansion](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-groups/) via keyboard requires holding down the `⌥ Alt` key in addition to pressing `↵ Enter`.

## Ranges with Pinned Columns and Rows

It is possible to select a cell range that spans pinned and non-pinned sections of the grid. If you do this, the selected range will not have any gaps with regards to the column or row order.

For example, if you start the drag on the left pinned area and drag to the right pinned area, then all of the columns in the centre area will also be part of the range. Likewise with pinned rows, no row gaps will occur if a cell range spans into pinned rows. A range will be continuous between the rows pinned to the top, the centre, and the rows pinned to the bottom.

This can be thought of as follows: if you have a grid with pinned rows and / or columns, then 'flatten out' the grid in your head so that all rows and columns are visible, then the cell selection will work as you would expect in the flattened out version where only full rectangles can be selectable.

#### Cell Range Selection and Pinned Areas

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  IsRowPinned,
  ModuleRegistry,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  PinnedRowModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [enableRowPinning]="true"
    [isRowPinned]="isRowPinned"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150, pinned: "left" },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total", pinned: "right" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  isRowPinned: IsRowPinned = (node) => {
    const country = node.data?.country;
    return country == "Norway" ? "top" : null;
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Range Selection and Pinned Areas](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-pinned-areas/angular/)

## Highlight Headers

It is possible to highlight the Grid Headers that are part of a range by setting the `cellSelection.enableHeaderHighlight` to `true`.

```ts
<ag-grid-angular
    [cellSelection]="cellSelection"
    /* other grid options ... */ />

this.cellSelection = {
    enableHeaderHighlight: true,
};
```

#### Cell Range Selection Header Highlight

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="cellSelection"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  cellSelection: boolean | CellSelectionOptions = {
    enableHeaderHighlight: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Range Selection Header Highlight](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-highlight-headers/angular/)

## Editing Within a Cell Selection

When [Cell Editing](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing/) is enabled, a cell selection can be used to edit many cells at once.

### Copy Cell Range Down

When you have more than one row selected in a range, pressing keys `^ Ctrl`+`D` will copy the top row values to all other rows in the selected range.

By default, the Value Formatter and Value Parser will be used whilst copying the range via the [Use Value Formatter For Export](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/#formatting-for-export) and [Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-parsers/#use-value-parser-for-import) features.

### Bulk Cell Edit

When a cell range is selected, typing to enter a new value and pressing the `^ Ctrl`+`↵ Enter` keys will set the newly provided cell value to all the editable cells in the selected cell range.

### Delete Cell Range

Pressing the `Delete` key will clear all of the cells in the range (by setting the cell values to `null`). If your column uses a `valueParser`, it will receive an empty string (`''`) as the new value.

This will also emit the following events:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellSelectionDeleteStart` | `CellSelectionDeleteStartEvent` |  |  |  |
| `cellSelectionDeleteEnd` | `CellSelectionDeleteEndEvent` |  |  |  |

### Example

The example below has editing enabled on all columns. Select a range of cells, then try each of the interactions described above.

#### Editing Within a Cell Selection

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Editing Within a Cell Selection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-editing/angular/)

## API Reference

> **Note**
>
> The cell selection state can be saved and restored as part of [Grid State](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/).

Here you can find a full list of configuration options for `cellSelection`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressMultiRanges` | `boolean` |  |  |  |
| `enableHeaderHighlight` | `boolean` |  |  |  |
| `enableColumnSelection` | `boolean` |  |  |  |
| `handle` | `RangeHandleOptions \| FillHandleOptions` |  |  |  |


---
product: "AG Grid"
title: "Cell Selection"
description: "Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the , or for doing aggregations using the ."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Row Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Cell Selection

Cell selection allows Excel-like selection of ranges of cells. Cell selections are useful for visually highlighting data, copying data to the [Clipboard](https://www.ag-grid.com/archive/36.2.0/react-data-grid/clipboard/), or for doing aggregations using the [Status Bar](https://www.ag-grid.com/archive/36.2.0/react-data-grid/status-bar/).

## Enabling Cell Selection

Cell Selection is enabled by setting the `gridOptions.cellSelection` to `true`, or to a configuration object.

```jsx
const cellSelection = true;

<AgGridReact cellSelection={cellSelection} />
```

When enabled, ranges can be selected in the following ways:

- **Mouse Drag:** Click the mouse down on a cell and drag and release the mouse over another cell. A range will be created between the two cells and clear any existing ranges.
- **Ctrl & Mouse Drag:** Holding `^ Ctrl` key while creating a range using mouse drag **outside an existing range** will create a new cell range selection and keep any existing ranges.
- **Shift & Click:** Clicking on one cell to focus that cell, then holding down `⇧ Shift` while clicking another cell, will create a range between both cells.
- **Shift & Arrow Keys:** Focusing a cell and then holding down `⇧ Shift` and using the arrow keys will create a range starting from the focused cell.
- **Ctrl & Shift & Arrow Keys:** Focusing a cell and then holding down `^ Ctrl` + `⇧ Shift` and using the arrow keys will create a range starting from the focused cell to the last cell in the direction of the Arrow pressed.

### Cell Range Deselection

It is possible to deselect part of existing ranges in the following ways:

- **Ctrl & Mouse Drag:** Holding `^ Ctrl` and dragging a range starting **within an existing range** will cause any cells covered by the new range to be deselected.
- **Ctrl & Click:** Holding `^ Ctrl` and clicking a cell will deselect just that cell.

Note that deselecting part of a range can split the range into multiple ranges, since individual ranges have the limitation of being rectangular.

The example below demonstrates simple cell selection. Cell ranges can be selected in all the ways described above.

#### Cell Range Selection and Deselection

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Range Selection and Deselection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection/reactFunctionalTs/)

## Prevent Selection of Multiple Ranges

By default multiple ranges can be selected. To restrict cell selection to a single range, even if the `^ Ctrl` key is held down, set `cellSelection.suppressMultiRanges` to `true`.

```jsx
const cellSelection = useMemo(() => { 
	return {
        suppressMultiRanges: true,
    };
}, []);

<AgGridReact cellSelection={cellSelection} />
```

The following example demonstrates single range cell selection:

#### Cell Range Selection Suppress Multi

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
    };
  }, []);
  const cellSelection = useMemo<boolean | CellSelectionOptions>(() => {
    return { suppressMultiRanges: true };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={cellSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Range Selection Suppress Multi](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-suppress-multi/reactFunctionalTs/)

## Selecting Cells via Column Headers

Users can select all visible cells in a column by setting `cellSelection.enableColumnSelection` to `true` and either clicking a column header, or pressing the `↵ Enter` key when the column header is focused.

- By default, when selecting a column, all other ranges are cleared. If you wish to keep existing selections, hold `^ Ctrl` and then select a column header.
- Cells that have been selected via column selection may be de-selected by holding `^ Ctrl` and then clicking the column header.
- Users can extend the range of a column selection by holding `⇧ Shift` and then clicking on another column header.
- When interacting via the keyboard, users may press `↵ Enter` while a column header is focussed instead of clicking a column header.

This feature is illustrated in the example below, which uses the following configuration:

```jsx
const cellSelection = useMemo(() => { 
	return {
        enableColumnSelection: true,
    };
}, []);

<AgGridReact cellSelection={cellSelection} />
```

#### Cell Selection via Column Headers

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    { field: "athlete", minWidth: 150 },
    {
      headerName: "Category A1",
      children: [
        { field: "age", maxWidth: 90 },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Category B1",
      children: [
        {
          headerName: "Category B2",
          children: [
            { field: "year", maxWidth: 90 },
            { field: "date", minWidth: 150 },
            { field: "sport", minWidth: 150 },
            { field: "gold" },
            { field: "silver" },
            { field: "bronze" },
            { field: "total" },
          ],
        },
      ],
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const cellSelection = useMemo<boolean | CellSelectionOptions>(() => {
    return {
      enableColumnSelection: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={cellSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Selection via Column Headers](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/column-header-cell-selection/reactFunctionalTs/)

> **Note**
>
> When column selection is enabled, [Row Sorting](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-sorting/) requires holding down the `⌥ Alt` key in addition to the normal interaction (i.e. clicking or pressing `↵ Enter`).
>
> Similarly [Column Group Expansion](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-groups/) via keyboard requires holding down the `⌥ Alt` key in addition to pressing `↵ Enter`.

## Ranges with Pinned Columns and Rows

It is possible to select a cell range that spans pinned and non-pinned sections of the grid. If you do this, the selected range will not have any gaps with regards to the column or row order.

For example, if you start the drag on the left pinned area and drag to the right pinned area, then all of the columns in the centre area will also be part of the range. Likewise with pinned rows, no row gaps will occur if a cell range spans into pinned rows. A range will be continuous between the rows pinned to the top, the centre, and the rows pinned to the bottom.

This can be thought of as follows: if you have a grid with pinned rows and / or columns, then 'flatten out' the grid in your head so that all rows and columns are visible, then the cell selection will work as you would expect in the flattened out version where only full rectangles can be selectable.

#### Cell Range Selection and Pinned Areas

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  IsRowPinned,
  ModuleRegistry,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  PinnedRowModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150, pinned: "left" },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total", pinned: "right" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const isRowPinned = useCallback((node) => {
    const country = node.data?.country;
    return country == "Norway" ? "top" : null;
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
            enableRowPinning={true}
            isRowPinned={isRowPinned}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Range Selection and Pinned Areas](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-pinned-areas/reactFunctionalTs/)

## Highlight Headers

It is possible to highlight the Grid Headers that are part of a range by setting the `cellSelection.enableHeaderHighlight` to `true`.

```jsx
const cellSelection = useMemo(() => { 
	return {
        enableHeaderHighlight: true,
    };
}, []);

<AgGridReact cellSelection={cellSelection} />
```

#### Cell Range Selection Header Highlight

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const cellSelection = useMemo<boolean | CellSelectionOptions>(() => {
    return {
      enableHeaderHighlight: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={cellSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Range Selection Header Highlight](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-highlight-headers/reactFunctionalTs/)

## Editing Within a Cell Selection

When [Cell Editing](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing/) is enabled, a cell selection can be used to edit many cells at once.

### Copy Cell Range Down

When you have more than one row selected in a range, pressing keys `^ Ctrl`+`D` will copy the top row values to all other rows in the selected range.

By default, the Value Formatter and Value Parser will be used whilst copying the range via the [Use Value Formatter For Export](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/#formatting-for-export) and [Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-parsers/#use-value-parser-for-import) features.

### Bulk Cell Edit

When a cell range is selected, typing to enter a new value and pressing the `^ Ctrl`+`↵ Enter` keys will set the newly provided cell value to all the editable cells in the selected cell range.

### Delete Cell Range

Pressing the `Delete` key will clear all of the cells in the range (by setting the cell values to `null`). If your column uses a `valueParser`, it will receive an empty string (`''`) as the new value.

This will also emit the following events:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellSelectionDeleteStart` | `CellSelectionDeleteStartEvent` |  |  |  |
| `cellSelectionDeleteEnd` | `CellSelectionDeleteEndEvent` |  |  |  |

### Example

The example below has editing enabled on all columns. Select a range of cells, then try each of the interactions described above.

#### Editing Within a Cell Selection

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  NumberEditorModule,
  TextEditorModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", maxWidth: 90 },
    { field: "country", minWidth: 150 },
    { field: "year", maxWidth: 90 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/small-olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Editing Within a Cell Selection](https://www.ag-grid.com/archive/36.2.0/examples/cell-selection/range-selection-editing/reactFunctionalTs/)

## API Reference

> **Note**
>
> The cell selection state can be saved and restored as part of [Grid State](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/).

Here you can find a full list of configuration options for `cellSelection`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressMultiRanges` | `boolean` |  |  |  |
| `enableHeaderHighlight` | `boolean` |  |  |  |
| `enableColumnSelection` | `boolean` |  |  |  |
| `handle` | `RangeHandleOptions \| FillHandleOptions` |  |  |  |
